unit uBizCobrosClienteServer;

interface

uses
  schCobrosClienteServer_Intf, uDAInterfaces,
  uDADataTable, uDABusinessProcessor;

const
  BIZ_SERVER_COBROS_CLIENTE = 'Server.CobrosCliente';
  REF_COBROS_CLIENTE = 'REF_COBROS_CLIENTE';

type
  TBizCobrosClienteServer = class(TCobrosClienteBusinessProcessorRules)
  protected
    procedure BeforeProcessChange(Sender: TDABusinessProcessor;
      aChangeType: TDAChangeType; aChange: TDADeltaChange;
      var ProcessChange: Boolean); override;
  end;

implementation

uses
  SysUtils, Variants, uDataModuleServer, uDAClasses, DARemoteService_Impl,
  schCobrosClienteClient_Intf, uBusinessUtils, uReferenciasUtils, uROClasses;

{ TBizCobrosClienteServer }

procedure TBizCobrosClienteServer.BeforeProcessChange(
  Sender: TDABusinessProcessor; aChangeType: TDAChangeType;
  aChange: TDADeltaChange; var ProcessChange: Boolean);
var
  ASchema : TDASchema;
  ACurrentConn : IDAConnection;
  dsData: IDADataset;
  Empresa : Variant;

begin
  inherited;
  case aChangeType of
    ctInsert, ctUpdate: begin
      //Si la referencia no ha sido asignada le asignamos una nosotros
      if (VarIsNull(aChange.NewValueByName[fld_CobrosClienteREFERENCIA]))
      or (VarToStr(aChange.NewValueByName[fld_CobrosClienteREFERENCIA]) = '') then
      begin
        ASchema := BusinessProcessor.Schema;
        ACurrentConn := GetBusinessProcessorConnection(BusinessProcessor);

        try
          //Siempre va a estar rellena
          Empresa := aChange.NewValueByName[fld_CobrosClienteID_EMPRESA];

          dsData := ASchema.NewDataset(ACurrentConn, 'DarReferencia', ['CODIGO', 'EMPRESA'], [REF_COBROS_CLIENTE, Empresa]);
        except
          RaiseError('No existe la tabla REFERENCIAS');
        end;

        dsData.Active := True;

        if dsData.IsEmpty then
          RaiseError('NO HAY REFERENCIA ' + REF_COBROS_CLIENTE + ' DECLARADA EN TABLA REFERENCIAS');

        REFERENCIA := dsData.FieldByName('VALOR').AsString;

        try
          ASchema.NewCommand(ACurrentConn, 'ModificarReferencia', ['CODIGO', 'VALOR', 'EMPRESA'], [REF_COBROS_CLIENTE, darReferenciaSiguiente(REFERENCIA), Empresa]);
        except
          RaiseError('Error al asignar la nueva ' + REFERENCIA + ' referencia en tabla');
        end;

      end;
    end;
  end;
end;

initialization
  RegisterBusinessProcessorRules(BIZ_SERVER_COBROS_CLIENTE, TBizCobrosClienteServer);

end.
